CS      EQU 20H
PA      EQU 21H
PB      EQU 22H
CP      EQU 23H
DISP    EQU 2000H
DISP1   EQU 2001H
DATO    EQU 2002H
VH      EQU 93H
VL      EQU 88H
TH      EQU 25H
TL      EQU 24H
MT      EQU 01H
CONS    EQU 0CH

        ORG 0000H
RESET:  JMP COMIEN
        ORG 24H
        JMP NMI

        ORG 4000H       ;ORG 40H
TABLA:  DB 3FH
        DB 06H
        DB 5BH
        DB 4FH
        DB 66H
        DB 6DH
        DB 7DH
        DB 07H
        DB 7FH
        DB 6FH
        NOP
        NOP
        NOP
        NOP
        NOP
NMI:    RET
COMIEN: LXI SP,20AFH
        LXI H,200FH
        MVI A,0
CERO:   MOV M,A
        DCR L
        JNZ CERO
        MVI A,03H       ;PA,PB SALIDA. CP ENTRADA             
        OUT CS
        MVI A,0
        SIM
INICIO: CALL OUTDP
        CALL IN
        JMP INICIO
;****************************
;*  RUTINAS                 *
;****************************
IN:     CALL TRANS      ;VALOR EN ACC
        CALL RANGO
        JNC BIEN
        MVI A,50H
        STA DISP
        MVI A,71H
        STA DISP1
        RC
BIEN:   CALL CONVBD
        CALL EXDAT
        RET

;***************************
;LECTURA DEL OSCILADOR
TRANS:  MVI A,VH
        OUT TH
        MVI A,VL
        OUT TL
TR0:    IN CP           ;ESPERA NIVEL ALTO
        ANI MT
        JZ TR0
TR1:    IN CP           ;ESPERA NIVEL BAJO
        ANI MT
        JNZ TR1
        MVI A,0C3H      ;ARRANCA TIMER
        OUT CS
TR2:    IN CP           ;ESPERA NIVEL ALTO
        ANI MT
        JZ TR2
        MVI A,43H       ;STOP TIMER
        OUT CS
        IN TL           ;LEE TIMER
        MOV C,A
        IN TH
        MOV B,A
        MVI H,VH
        MVI L,VL
        CALL TRT        ;EN HL TIMER
        MOV A,H         ;DIVIDIR POR 64
        RLC
        RLC
        RLC
        ANI 0F8H
        MOV H,A
        MOV A,L
        RRC
        RRC
        RRC
        ANI 07H
        ORA H
        SUI CONS        ;A VALOR
        RET
;*******************************************
;RUTINA DE CALCULO TIMER
;ENTRADA: BC MEDIDA, HL VALOR PRECARGA TIMER
;SALIDA: HL VALOR REAL TIMER
TRT:    MOV A,B
        ANI 3FH
        RAR
        MOV B,A
        MOV A,C
        RAR
        MOV C,A
        RNC
        CMC
        CALL ROT16
        DAD B
        RET

ROT16:  MOV A,H
        RAR
        MOV H,A
        MOV A,L
        RAR
        MOV L,A
        RET

RANGO:  ORA A
        CPI 29H
        JM NOFR
        STC
        RET
NOFR:   CPI 0000H
        RP
        STC
        RET
;***************************
;CONVERSION HEX A BCD
CONVBD: MVI C,0
        MOV B,A
SIGUE:  MOV A,B
        DCR A
        MOV B,A
        JZ SALIR
        MOV A,C
        ADI 1
        DAA
        MOV C,A
        JMP SIGUE
SALIR:  MOV A,C
        ADI 1
        DAA
        STA DATO
        RET

EXDAT:  LDA DATO
        ANI 0FH
        STA DISP
        LDA DATO
        ANI 0F0H
        RRC
        RRC
        RRC
        RRC
        STA DISP1
        RET
OUTDP:  LXI H,DISP
        MVI B,1H
MUX:    MOV A,M
        XCHG
        LXI H,TABLA
        ADD L
        MOV L,A
        MOV A,M
        XCHG
        CMA
        OUT PA
        MOV A,B
        OUT PB
        MVI D,9DH
DELAY:  DCR D 
        JNZ DELAY
        INX H
        MOV A,B
        RLC
        MOV B,A
        CPI 04H
        JNZ MUX
        RET

